Add -z bndplt support (for Intel MPX).

2016-12-15  Cary Coutant  <ccoutant@gmail.com>

gold/
	PR gold/17643
	* options.h (-z bndplt): New option.
	* x86_64.cc (Output_data_plt_x86_64::regular_count): New method.
	(Output_data_plt_x86_64::address_for_global): Move implementation into
	virtual method.
	(Output_data_plt_x86_64::address_for_local): Likewise.
	(Output_data_plt_x86_64::got): New method.
	(Output_data_plt_x86_64::got_plt): New method.
	(Output_data_plt_x86_64::got_irelative): New method.
	(Output_data_plt_x86_64::do_address_for_global): New virtual method.
	(Output_data_plt_x86_64::do_address_for_local): New virtual method.
	(class Output_data_plt_x86_64_bnd): New class.
	(Target_x86_64::do_make_data_plt): Move out of line and specialize
	for each size (both overloads).
	(Output_data_plt_x86_64::set_final_data_size): Cosmetic changes.


diff --git a/gold/options.h b/gold/options.h
index ebe08df..32d8b05 100644
--- a/gold/options.h
+++ b/gold/options.h
@@ -1403,6 +1403,9 @@ class General_options
 
   // The -z options.
 
+  DEFINE_bool(bndplt, options::DASH_Z, '\0', false,
+	      N_("(x86-64 only) Generate a BND PLT for Intel MPX"),
+	      N_("Generate a regular PLT"));
   DEFINE_bool(combreloc, options::DASH_Z, '\0', true,
 	      N_("Sort dynamic relocs"),
 	      N_("Do not sort dynamic relocs"));
diff --git a/gold/x86_64.cc b/gold/x86_64.cc
index 9004aec..7837f67 100644
--- a/gold/x86_64.cc
+++ b/gold/x86_64.cc
@@ -179,7 +179,12 @@ class Output_data_plt_x86_64 : public Output_section_data
   has_irelative_section() const
   { return this->irelative_rel_ != NULL; }
 
-  // Return the number of PLT entries.
+  // Get count of regular PLT entries.
+  unsigned int
+  regular_count() const
+  { return this->count_; }
+
+  // Return the total number of PLT entries.
   unsigned int
   entry_count() const
   { return this->count_ + this->irelative_count_; }
@@ -204,11 +209,13 @@ class Output_data_plt_x86_64 : public Output_section_data
 
   // Return the PLT address to use for a global symbol.
   uint64_t
-  address_for_global(const Symbol*);
+  address_for_global(const Symbol* sym)
+  { return do_address_for_global(sym); }
 
   // Return the PLT address to use for a local symbol.
   uint64_t
-  address_for_local(const Relobj*, unsigned int symndx);
+  address_for_local(const Relobj* obj, unsigned int symndx)
+  { return do_address_for_local(obj, symndx); }
 
   // Add .eh_frame information for the PLT.
   void
@@ -216,6 +223,18 @@ class Output_data_plt_x86_64 : public Output_section_data
   { this->do_add_eh_frame(layout); }
 
  protected:
+  Output_data_got<64, false>*
+  got() const
+  { return this->got_; }
+
+  Output_data_got_plt_x86_64*
+  got_plt() const
+  { return this->got_plt_; }
+
+  Output_data_space*
+  got_irelative() const
+  { return this->got_irelative_; }
+
   // Fill in the first PLT entry.
   void
   fill_first_plt_entry(unsigned char* pov,
@@ -275,6 +294,14 @@ class Output_data_plt_x86_64 : public Output_section_data
 			unsigned int tlsdesc_got_offset,
 			unsigned int plt_offset) = 0;
 
+  // Return the PLT address to use for a global symbol.
+  virtual uint64_t
+  do_address_for_global(const Symbol* sym);
+
+  // Return the PLT address to use for a local symbol.
+  virtual uint64_t
+  do_address_for_local(const Relobj* obj, unsigned int symndx);
+
   virtual void
   do_add_eh_frame(Layout* layout) = 0;
 
@@ -403,6 +430,121 @@ class Output_data_plt_x86_64_standard : public Output_data_plt_x86_64<size>
   static const unsigned char plt_eh_frame_fde[plt_eh_frame_fde_size];
 };
 
+class Output_data_plt_x86_64_bnd : public Output_data_plt_x86_64<64>
+{
+ public:
+  Output_data_plt_x86_64_bnd(Layout* layout,
+			     Output_data_got<64, false>* got,
+			     Output_data_got_plt_x86_64* got_plt,
+			     Output_data_space* got_irelative)
+    : Output_data_plt_x86_64<64>(layout, plt_entry_size,
+				 got, got_plt, got_irelative),
+      aplt_offset_(0)
+  { }
+
+  Output_data_plt_x86_64_bnd(Layout* layout,
+			     Output_data_got<64, false>* got,
+			     Output_data_got_plt_x86_64* got_plt,
+			     Output_data_space* got_irelative,
+			     unsigned int plt_count)
+    : Output_data_plt_x86_64<64>(layout, plt_entry_size,
+				 got, got_plt, got_irelative,
+				 plt_count),
+      aplt_offset_(0)
+  { }
+
+ protected:
+  virtual unsigned int
+  do_get_plt_entry_size() const
+  { return plt_entry_size; }
+
+  // Return the PLT address to use for a global symbol.
+  uint64_t
+  do_address_for_global(const Symbol*);
+
+  // Return the PLT address to use for a local symbol.
+  uint64_t
+  do_address_for_local(const Relobj*, unsigned int symndx);
+
+  virtual void
+  do_add_eh_frame(Layout* layout)
+  {
+    layout->add_eh_frame_for_plt(this,
+				 this->plt_eh_frame_cie,
+				 this->plt_eh_frame_cie_size,
+				 plt_eh_frame_fde,
+				 plt_eh_frame_fde_size);
+  }
+
+  virtual void
+  do_fill_first_plt_entry(unsigned char* pov,
+			  typename elfcpp::Elf_types<64>::Elf_Addr got_addr,
+			  typename elfcpp::Elf_types<64>::Elf_Addr plt_addr);
+
+  virtual unsigned int
+  do_fill_plt_entry(unsigned char* pov,
+		    typename elfcpp::Elf_types<64>::Elf_Addr got_address,
+		    typename elfcpp::Elf_types<64>::Elf_Addr plt_address,
+		    unsigned int got_offset,
+		    unsigned int plt_offset,
+		    unsigned int plt_index);
+
+  virtual void
+  do_fill_tlsdesc_entry(unsigned char* pov,
+			typename elfcpp::Elf_types<64>::Elf_Addr got_address,
+			typename elfcpp::Elf_types<64>::Elf_Addr plt_address,
+			typename elfcpp::Elf_types<64>::Elf_Addr got_base,
+			unsigned int tlsdesc_got_offset,
+			unsigned int plt_offset);
+
+  void
+  fill_aplt_entry(unsigned char* pov,
+		  typename elfcpp::Elf_types<64>::Elf_Addr got_address,
+		  typename elfcpp::Elf_types<64>::Elf_Addr plt_address,
+		  unsigned int got_offset,
+		  unsigned int plt_offset,
+		  unsigned int plt_index);
+
+ private:
+  // Set the final size.
+  void
+  set_final_data_size();
+
+  // Write out the BND PLT data.
+  void
+  do_write(Output_file*);
+
+  // Offset of the Additional PLT (if using -z bndplt).
+  unsigned int aplt_offset_;
+
+  // The size of an entry in the PLT.
+  static const int plt_entry_size = 16;
+
+  // The size of an entry in the additional PLT.
+  static const int aplt_entry_size = 8;
+
+  // The first entry in the PLT.
+  // From the AMD64 ABI: "Unlike Intel386 ABI, this ABI uses the same
+  // procedure linkage table for both programs and shared objects."
+  static const unsigned char first_plt_entry[plt_entry_size];
+
+  // Other entries in the PLT for an executable.
+  static const unsigned char plt_entry[plt_entry_size];
+
+  // Entries in the additional PLT.
+  static const unsigned char aplt_entry[aplt_entry_size];
+
+  // The reserved TLSDESC entry in the PLT for an executable.
+  static const unsigned char tlsdesc_plt_entry[plt_entry_size];
+
+  // The .eh_frame unwind information for the PLT.
+  static const int plt_eh_frame_fde_size = 32;
+  static const unsigned char plt_eh_frame_fde[plt_eh_frame_fde_size];
+
+  static const int aplt_eh_frame_fde_size = 32;
+  static const unsigned char aplt_eh_frame_fde[plt_eh_frame_fde_size];
+};
+
 template<int size>
 class Lazy_view
 {
@@ -714,23 +856,14 @@ class Target_x86_64 : public Sized_target<size, false>
   do_make_data_plt(Layout* layout,
 		   Output_data_got<64, false>* got,
 		   Output_data_got_plt_x86_64* got_plt,
-		   Output_data_space* got_irelative)
-  {
-    return new Output_data_plt_x86_64_standard<size>(layout, got, got_plt,
-						     got_irelative);
-  }
+		   Output_data_space* got_irelative);
 
   virtual Output_data_plt_x86_64<size>*
   do_make_data_plt(Layout* layout,
 		   Output_data_got<64, false>* got,
 		   Output_data_got_plt_x86_64* got_plt,
 		   Output_data_space* got_irelative,
-		   unsigned int plt_count)
-  {
-    return new Output_data_plt_x86_64_standard<size>(layout, got, got_plt,
-						     got_irelative,
-						     plt_count);
-  }
+		   unsigned int plt_count);
 
  private:
   // The class which scans relocations.
@@ -1528,7 +1661,7 @@ Output_data_plt_x86_64<size>::rela_irelative(Symbol_table* symtab,
 
 template<int size>
 uint64_t
-Output_data_plt_x86_64<size>::address_for_global(const Symbol* gsym)
+Output_data_plt_x86_64<size>::do_address_for_global(const Symbol* gsym)
 {
   uint64_t offset = 0;
   if (gsym->type() == elfcpp::STT_GNU_IFUNC
@@ -1542,8 +1675,8 @@ Output_data_plt_x86_64<size>::address_for_global(const Symbol* gsym)
 
 template<int size>
 uint64_t
-Output_data_plt_x86_64<size>::address_for_local(const Relobj* object,
-						unsigned int r_sym)
+Output_data_plt_x86_64<size>::do_address_for_local(const Relobj* object,
+						   unsigned int r_sym)
 {
   return (this->address()
 	  + (this->count_ + 1) * this->get_plt_entry_size()
@@ -1555,10 +1688,12 @@ template<int size>
 void
 Output_data_plt_x86_64<size>::set_final_data_size()
 {
-  unsigned int count = this->count_ + this->irelative_count_;
+  // Number of regular and IFUNC PLT entries, plus the first entry.
+  unsigned int count = this->count_ + this->irelative_count_ + 1;
+  // Count the TLSDESC entry, if present.
   if (this->has_tlsdesc_entry())
     ++count;
-  this->set_data_size((count + 1) * this->get_plt_entry_size());
+  this->set_data_size(count * this->get_plt_entry_size());
 }
 
 // The first entry in the PLT for an executable.
@@ -1673,6 +1808,176 @@ Output_data_plt_x86_64_standard<size>::do_fill_tlsdesc_entry(
 						  + 12)));
 }
 
+// Return the APLT address to use for a global symbol (for -z bndplt).
+
+uint64_t
+Output_data_plt_x86_64_bnd::do_address_for_global(const Symbol* gsym)
+{
+  uint64_t offset = this->aplt_offset_;
+  if (gsym->type() == elfcpp::STT_GNU_IFUNC
+      && gsym->can_use_relative_reloc(false))
+    offset += this->regular_count() * aplt_entry_size;
+  // Convert the PLT offset into an APLT offset.
+  unsigned int plt_offset = ((gsym->plt_offset() - plt_entry_size)
+  			     / (plt_entry_size / aplt_entry_size));
+  return this->address() + offset + plt_offset;
+}
+
+// Return the PLT address to use for a local symbol.  These are always
+// IRELATIVE relocs.
+
+uint64_t
+Output_data_plt_x86_64_bnd::do_address_for_local(const Relobj* object,
+						 unsigned int r_sym)
+{
+  // Convert the PLT offset into an APLT offset.
+  unsigned int plt_offset = ((object->local_plt_offset(r_sym) - plt_entry_size)
+			     / (plt_entry_size / aplt_entry_size));
+  return (this->address()
+	  + this->aplt_offset_
+	  + this->regular_count() * aplt_entry_size
+	  + plt_offset);
+}
+
+// Set the final size.
+void
+Output_data_plt_x86_64_bnd::set_final_data_size()
+{
+  // Number of regular and IFUNC PLT entries.
+  unsigned int count = this->entry_count();
+  // Count the first entry and the TLSDESC entry, if present.
+  unsigned int extra = this->has_tlsdesc_entry() ? 2 : 1;
+  unsigned int plt_size = (count + extra) * plt_entry_size;
+  // Offset of the APLT.
+  this->aplt_offset_ = plt_size;
+  // Size of the APLT.
+  plt_size += count * aplt_entry_size;
+  this->set_data_size(plt_size);
+}
+
+// The first entry in the BND PLT.
+
+const unsigned char
+Output_data_plt_x86_64_bnd::first_plt_entry[plt_entry_size] =
+{
+  // From AMD64 ABI Draft 0.98, page 76
+  0xff, 0x35,		// pushq contents of memory address
+  0, 0, 0, 0,		// replaced with address of .got + 8
+  0xf2, 0xff, 0x25,	// bnd jmp indirect
+  0, 0, 0, 0,		// replaced with address of .got + 16
+  0x0f, 0x1f, 0x00   	// nop
+};
+
+void
+Output_data_plt_x86_64_bnd::do_fill_first_plt_entry(
+    unsigned char* pov,
+    typename elfcpp::Elf_types<64>::Elf_Addr got_address,
+    typename elfcpp::Elf_types<64>::Elf_Addr plt_address)
+{
+  memcpy(pov, first_plt_entry, plt_entry_size);
+  // We do a jmp relative to the PC at the end of this instruction.
+  elfcpp::Swap_unaligned<32, false>::writeval(pov + 2,
+					      (got_address + 8
+					       - (plt_address + 6)));
+  elfcpp::Swap<32, false>::writeval(pov + 9,
+				    (got_address + 16
+				     - (plt_address + 13)));
+}
+
+// Subsequent entries in the BND PLT.
+
+const unsigned char
+Output_data_plt_x86_64_bnd::plt_entry[plt_entry_size] =
+{
+  // From AMD64 ABI Draft 0.99.8, page 139
+  0x68,				// pushq immediate
+  0, 0, 0, 0,			// replaced with offset into relocation table
+  0xf2, 0xe9,			// bnd jmpq relative
+  0, 0, 0, 0,			// replaced with offset to start of .plt
+  0x0f, 0x1f, 0x44, 0, 0	// nop
+};
+
+// Entries in the BND Additional PLT.
+
+const unsigned char
+Output_data_plt_x86_64_bnd::aplt_entry[aplt_entry_size] =
+{
+  // From AMD64 ABI Draft 0.99.8, page 139
+  0xf2, 0xff, 0x25,	// bnd jmpq indirect
+  0, 0, 0, 0,		// replaced with address of symbol in .got
+  0x90,			// nop
+};
+
+unsigned int
+Output_data_plt_x86_64_bnd::do_fill_plt_entry(
+    unsigned char* pov,
+    typename elfcpp::Elf_types<64>::Elf_Addr,
+    typename elfcpp::Elf_types<64>::Elf_Addr,
+    unsigned int,
+    unsigned int plt_offset,
+    unsigned int plt_index)
+{
+  memcpy(pov, plt_entry, plt_entry_size);
+  elfcpp::Swap_unaligned<32, false>::writeval(pov + 1, plt_index);
+  elfcpp::Swap<32, false>::writeval(pov + 7, -(plt_offset + 11));
+  return 0;
+}
+
+void
+Output_data_plt_x86_64_bnd::fill_aplt_entry(
+    unsigned char* pov,
+    typename elfcpp::Elf_types<64>::Elf_Addr got_address,
+    typename elfcpp::Elf_types<64>::Elf_Addr plt_address,
+    unsigned int got_offset,
+    unsigned int plt_offset,
+    unsigned int plt_index)
+{
+  // Check PC-relative offset overflow in PLT entry.
+  uint64_t plt_got_pcrel_offset = (got_address + got_offset
+				   - (plt_address + plt_offset + 7));
+  if (Bits<32>::has_overflow(plt_got_pcrel_offset))
+    gold_error(_("PC-relative offset overflow in APLT entry %d"),
+	       plt_index + 1);
+
+  memcpy(pov, aplt_entry, aplt_entry_size);
+  elfcpp::Swap_unaligned<32, false>::writeval(pov + 3, plt_got_pcrel_offset);
+}
+
+// The reserved TLSDESC entry in the PLT for an executable.
+
+const unsigned char
+Output_data_plt_x86_64_bnd::tlsdesc_plt_entry[plt_entry_size] =
+{
+  // From Alexandre Oliva, "Thread-Local Storage Descriptors for IA32
+  // and AMD64/EM64T", Version 0.9.4 (2005-10-10).
+  0xff, 0x35,		// pushq x(%rip)
+  0, 0, 0, 0,		// replaced with address of linkmap GOT entry (at PLTGOT + 8)
+  0xf2, 0xff, 0x25,	// jmpq *y(%rip)
+  0, 0, 0, 0,		// replaced with offset of reserved TLSDESC_GOT entry
+  0x0f,	0x1f, 0		// nop
+};
+
+void
+Output_data_plt_x86_64_bnd::do_fill_tlsdesc_entry(
+    unsigned char* pov,
+    typename elfcpp::Elf_types<64>::Elf_Addr got_address,
+    typename elfcpp::Elf_types<64>::Elf_Addr plt_address,
+    typename elfcpp::Elf_types<64>::Elf_Addr got_base,
+    unsigned int tlsdesc_got_offset,
+    unsigned int plt_offset)
+{
+  memcpy(pov, tlsdesc_plt_entry, plt_entry_size);
+  elfcpp::Swap_unaligned<32, false>::writeval(pov + 2,
+					      (got_address + 8
+					       - (plt_address + plt_offset
+						  + 6)));
+  elfcpp::Swap_unaligned<32, false>::writeval(pov + 9,
+					      (got_base
+					       + tlsdesc_got_offset
+					       - (plt_address + plt_offset
+						  + 13)));
+}
+
 // The .eh_frame unwind information for the PLT.
 
 template<int size>
@@ -1723,6 +2028,62 @@ Output_data_plt_x86_64_standard<size>::plt_eh_frame_fde[plt_eh_frame_fde_size] =
   elfcpp::DW_CFA_nop
 };
 
+// FIXME: Adjust for BND PLT entry.
+const unsigned char
+Output_data_plt_x86_64_bnd::plt_eh_frame_fde[plt_eh_frame_fde_size] =
+{
+  0, 0, 0, 0,				// Replaced with offset to .plt.
+  0, 0, 0, 0,				// Replaced with size of .plt.
+  0,					// Augmentation size.
+  elfcpp::DW_CFA_def_cfa_offset, 16,	// DW_CFA_def_cfa_offset: 16.
+  elfcpp::DW_CFA_advance_loc + 6,	// Advance 6 to __PLT__ + 6.
+  elfcpp::DW_CFA_def_cfa_offset, 24,	// DW_CFA_def_cfa_offset: 24.
+  elfcpp::DW_CFA_advance_loc + 10,	// Advance 10 to __PLT__ + 16.
+  elfcpp::DW_CFA_def_cfa_expression,	// DW_CFA_def_cfa_expression.
+  11,					// Block length.
+  elfcpp::DW_OP_breg7, 8,		// Push %rsp + 8.
+  elfcpp::DW_OP_breg16, 0,		// Push %rip.
+  elfcpp::DW_OP_lit15,			// Push 0xf.
+  elfcpp::DW_OP_and,			// & (%rip & 0xf).
+  elfcpp::DW_OP_lit11,			// Push 0xb.
+  elfcpp::DW_OP_ge,			// >= ((%rip & 0xf) >= 0xb)
+  elfcpp::DW_OP_lit3,			// Push 3.
+  elfcpp::DW_OP_shl,			// << (((%rip & 0xf) >= 0xb) << 3)
+  elfcpp::DW_OP_plus,			// + ((((%rip&0xf)>=0xb)<<3)+%rsp+8
+  elfcpp::DW_CFA_nop,			// Align to 32 bytes.
+  elfcpp::DW_CFA_nop,
+  elfcpp::DW_CFA_nop,
+  elfcpp::DW_CFA_nop
+};
+
+// FIXME: Adjust for APLT entry.
+const unsigned char
+Output_data_plt_x86_64_bnd::aplt_eh_frame_fde[aplt_eh_frame_fde_size] =
+{
+  0, 0, 0, 0,				// Replaced with offset to .plt.
+  0, 0, 0, 0,				// Replaced with size of .plt.
+  0,					// Augmentation size.
+  elfcpp::DW_CFA_def_cfa_offset, 16,	// DW_CFA_def_cfa_offset: 16.
+  elfcpp::DW_CFA_advance_loc + 6,	// Advance 6 to __PLT__ + 6.
+  elfcpp::DW_CFA_def_cfa_offset, 24,	// DW_CFA_def_cfa_offset: 24.
+  elfcpp::DW_CFA_advance_loc + 10,	// Advance 10 to __PLT__ + 16.
+  elfcpp::DW_CFA_def_cfa_expression,	// DW_CFA_def_cfa_expression.
+  11,					// Block length.
+  elfcpp::DW_OP_breg7, 8,		// Push %rsp + 8.
+  elfcpp::DW_OP_breg16, 0,		// Push %rip.
+  elfcpp::DW_OP_lit15,			// Push 0xf.
+  elfcpp::DW_OP_and,			// & (%rip & 0xf).
+  elfcpp::DW_OP_lit11,			// Push 0xb.
+  elfcpp::DW_OP_ge,			// >= ((%rip & 0xf) >= 0xb)
+  elfcpp::DW_OP_lit3,			// Push 3.
+  elfcpp::DW_OP_shl,			// << (((%rip & 0xf) >= 0xb) << 3)
+  elfcpp::DW_OP_plus,			// + ((((%rip&0xf)>=0xb)<<3)+%rsp+8
+  elfcpp::DW_CFA_nop,			// Align to 32 bytes.
+  elfcpp::DW_CFA_nop,
+  elfcpp::DW_CFA_nop,
+  elfcpp::DW_CFA_nop
+};
+
 // Write out the PLT.  This uses the hand-coded instructions above,
 // and adjusts them as needed.  This is specified by the AMD64 ABI.
 
@@ -1802,6 +2163,100 @@ Output_data_plt_x86_64<size>::do_write(Output_file* of)
   of->write_output_view(got_file_offset, got_size, got_view);
 }
 
+// Write out the BND PLT.
+
+void
+Output_data_plt_x86_64_bnd::do_write(Output_file* of)
+{
+  const off_t offset = this->offset();
+  const section_size_type oview_size =
+    convert_to_section_size_type(this->data_size());
+  unsigned char* const oview = of->get_output_view(offset, oview_size);
+
+  Output_data_got<64, false>* got = this->got();
+  Output_data_got_plt_x86_64* got_plt = this->got_plt();
+  Output_data_space* got_irelative = this->got_irelative();
+
+  const off_t got_file_offset = got_plt->offset();
+  gold_assert(parameters->incremental_update()
+	      || (got_file_offset + got_plt->data_size()
+		  == got_irelative->offset()));
+  const section_size_type got_size =
+    convert_to_section_size_type(got_plt->data_size()
+				 + got_irelative->data_size());
+  unsigned char* const got_view = of->get_output_view(got_file_offset,
+						      got_size);
+
+  unsigned char* pov = oview;
+
+  // The base address of the .plt section.
+  typename elfcpp::Elf_types<64>::Elf_Addr plt_address = this->address();
+  // The base address of the .got section.
+  typename elfcpp::Elf_types<64>::Elf_Addr got_base = got->address();
+  // The base address of the PLT portion of the .got section,
+  // which is where the GOT pointer will point, and where the
+  // three reserved GOT entries are located.
+  typename elfcpp::Elf_types<64>::Elf_Addr got_address = got_plt->address();
+
+  this->fill_first_plt_entry(pov, got_address, plt_address);
+  pov += plt_entry_size;
+
+  // The first three entries in the GOT are reserved, and are written
+  // by Output_data_got_plt_x86_64::do_write.
+  unsigned char* got_pov = got_view + 24;
+
+  unsigned int plt_offset = plt_entry_size;
+  unsigned int got_offset = 24;
+  const unsigned int count = this->entry_count();
+  for (unsigned int plt_index = 0;
+       plt_index < count;
+       ++plt_index,
+	 pov += plt_entry_size,
+	 got_pov += 8,
+	 plt_offset += plt_entry_size,
+	 got_offset += 8)
+    {
+      // Set and adjust the PLT entry itself.
+      unsigned int lazy_offset = this->fill_plt_entry(pov,
+						      got_address, plt_address,
+						      got_offset, plt_offset,
+						      plt_index);
+
+      // Set the entry in the GOT.
+      elfcpp::Swap<64, false>::writeval(got_pov,
+					plt_address + plt_offset + lazy_offset);
+    }
+
+  if (this->has_tlsdesc_entry())
+    {
+      // Set and adjust the reserved TLSDESC PLT entry.
+      unsigned int tlsdesc_got_offset = this->get_tlsdesc_got_offset();
+      this->fill_tlsdesc_entry(pov, got_address, plt_address, got_base,
+			       tlsdesc_got_offset, plt_offset);
+      pov += this->get_plt_entry_size();
+    }
+
+  // Write the additional PLT.
+  got_offset = 24;
+  for (unsigned int plt_index = 0;
+       plt_index < count;
+       ++plt_index,
+	 pov += aplt_entry_size,
+	 plt_offset += aplt_entry_size,
+	 got_offset += 8)
+    {
+      // Set and adjust the PLT entry itself.
+      this->fill_aplt_entry(pov, got_address, plt_address, got_offset,
+			    plt_offset, plt_index);
+    }
+
+  gold_assert(static_cast<section_size_type>(pov - oview) == oview_size);
+  gold_assert(static_cast<section_size_type>(got_pov - got_view) == got_size);
+
+  of->write_output_view(offset, oview_size, oview);
+  of->write_output_view(got_file_offset, got_size, got_view);
+}
+
 // Create the PLT section.
 
 template<int size>
@@ -1831,6 +2286,62 @@ Target_x86_64<size>::make_plt_section(Symbol_table* symtab, Layout* layout)
     }
 }
 
+template<>
+Output_data_plt_x86_64<32>*
+Target_x86_64<32>::do_make_data_plt(Layout* layout,
+				    Output_data_got<64, false>* got,
+				    Output_data_got_plt_x86_64* got_plt,
+				    Output_data_space* got_irelative)
+{
+  return new Output_data_plt_x86_64_standard<32>(layout, got, got_plt,
+						 got_irelative);
+}
+
+template<>
+Output_data_plt_x86_64<64>*
+Target_x86_64<64>::do_make_data_plt(Layout* layout,
+				    Output_data_got<64, false>* got,
+				    Output_data_got_plt_x86_64* got_plt,
+				    Output_data_space* got_irelative)
+{
+  if (parameters->options().bndplt())
+    return new Output_data_plt_x86_64_bnd(layout, got, got_plt,
+					  got_irelative);
+  else
+    return new Output_data_plt_x86_64_standard<64>(layout, got, got_plt,
+						   got_irelative);
+}
+
+template<>
+Output_data_plt_x86_64<32>*
+Target_x86_64<32>::do_make_data_plt(Layout* layout,
+				    Output_data_got<64, false>* got,
+				    Output_data_got_plt_x86_64* got_plt,
+				    Output_data_space* got_irelative,
+				    unsigned int plt_count)
+{
+  return new Output_data_plt_x86_64_standard<32>(layout, got, got_plt,
+						 got_irelative,
+						 plt_count);
+}
+
+template<>
+Output_data_plt_x86_64<64>*
+Target_x86_64<64>::do_make_data_plt(Layout* layout,
+				    Output_data_got<64, false>* got,
+				    Output_data_got_plt_x86_64* got_plt,
+				    Output_data_space* got_irelative,
+				    unsigned int plt_count)
+{
+  if (parameters->options().bndplt())
+    return new Output_data_plt_x86_64_bnd(layout, got, got_plt,
+					  got_irelative, plt_count);
+  else
+    return new Output_data_plt_x86_64_standard<64>(layout, got, got_plt,
+						   got_irelative,
+						   plt_count);
+}
+
 // Return the section for TLSDESC relocations.
 
 template<int size>
